(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.

(* Why3 assumption *)
Definition unit  := unit.

(* Why3 assumption *)
Inductive list (a:Type) {a_WT:WhyType a} :=
  | Nil : list a
  | Cons : a -> (list a) -> list a.
Axiom list_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (list a).
Existing Instance list_WhyType.
Implicit Arguments Nil [[a] [a_WT]].
Implicit Arguments Cons [[a] [a_WT]].

(* Why3 assumption *)
Fixpoint infix_plpl {a:Type} {a_WT:WhyType a}(l1:(list a)) (l2:(list
  a)) {struct l1}: (list a) :=
  match l1 with
  | Nil => l2
  | (Cons x1 r1) => (Cons x1 (infix_plpl r1 l2))
  end.

Axiom Append_assoc : forall {a:Type} {a_WT:WhyType a}, forall (l1:(list a))
  (l2:(list a)) (l3:(list a)), ((infix_plpl l1 (infix_plpl l2
  l3)) = (infix_plpl (infix_plpl l1 l2) l3)).

Axiom Append_l_nil : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  ((infix_plpl l (Nil :(list a))) = l).

(* Why3 assumption *)
Fixpoint length {a:Type} {a_WT:WhyType a}(l:(list
  a)) {struct l}: BuiltIn.int :=
  match l with
  | Nil => 0%Z
  | (Cons _ r) => (1%Z + (length r))%Z
  end.

Axiom Length_nonnegative : forall {a:Type} {a_WT:WhyType a}, forall (l:(list
  a)), (0%Z <= (length l))%Z.

Axiom Length_nil : forall {a:Type} {a_WT:WhyType a}, forall (l:(list a)),
  ((length l) = 0%Z) <-> (l = (Nil :(list a))).

Axiom Append_length : forall {a:Type} {a_WT:WhyType a}, forall (l1:(list a))
  (l2:(list a)), ((length (infix_plpl l1
  l2)) = ((length l1) + (length l2))%Z).

(* Why3 assumption *)
Fixpoint mem {a:Type} {a_WT:WhyType a}(x:a) (l:(list a)) {struct l}: Prop :=
  match l with
  | Nil => False
  | (Cons y r) => (x = y) \/ (mem x r)
  end.

Axiom mem_append : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l1:(list
  a)) (l2:(list a)), (mem x (infix_plpl l1 l2)) <-> ((mem x l1) \/ (mem x
  l2)).

Axiom mem_decomp : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (l:(list
  a)), (mem x l) -> exists l1:(list a), exists l2:(list a),
  (l = (infix_plpl l1 (Cons x l2))).

Parameter map : forall (a:Type) {a_WT:WhyType a} (b:Type) {b_WT:WhyType b},
  Type.
Axiom map_WhyType : forall (a:Type) {a_WT:WhyType a}
  (b:Type) {b_WT:WhyType b}, WhyType (map a b).
Existing Instance map_WhyType.

Parameter get: forall {a:Type} {a_WT:WhyType a} {b:Type} {b_WT:WhyType b},
  (map a b) -> a -> b.

Parameter set: forall {a:Type} {a_WT:WhyType a} {b:Type} {b_WT:WhyType b},
  (map a b) -> a -> b -> (map a b).

Axiom Select_eq : forall {a:Type} {a_WT:WhyType a} {b:Type} {b_WT:WhyType b},
  forall (m:(map a b)), forall (a1:a) (a2:a), forall (b1:b), (a1 = a2) ->
  ((get (set m a1 b1) a2) = b1).

Axiom Select_neq : forall {a:Type} {a_WT:WhyType a}
  {b:Type} {b_WT:WhyType b}, forall (m:(map a b)), forall (a1:a) (a2:a),
  forall (b1:b), (~ (a1 = a2)) -> ((get (set m a1 b1) a2) = (get m a2)).

Parameter const: forall {a:Type} {a_WT:WhyType a} {b:Type} {b_WT:WhyType b},
  b -> (map a b).

Axiom Const : forall {a:Type} {a_WT:WhyType a} {b:Type} {b_WT:WhyType b},
  forall (b1:b) (a1:a), ((get (const b1:(map a b)) a1) = b1).

(* Why3 assumption *)
Inductive array (a:Type) {a_WT:WhyType a} :=
  | mk_array : BuiltIn.int -> (map BuiltIn.int a) -> array a.
Axiom array_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (array a).
Existing Instance array_WhyType.
Implicit Arguments mk_array [[a] [a_WT]].

(* Why3 assumption *)
Definition elts {a:Type} {a_WT:WhyType a}(v:(array a)): (map BuiltIn.int
  a) := match v with
  | (mk_array x x1) => x1
  end.

(* Why3 assumption *)
Definition length1 {a:Type} {a_WT:WhyType a}(v:(array a)): BuiltIn.int :=
  match v with
  | (mk_array x x1) => x
  end.

(* Why3 assumption *)
Definition get1 {a:Type} {a_WT:WhyType a}(a1:(array a)) (i:BuiltIn.int): a :=
  (get (elts a1) i).

(* Why3 assumption *)
Definition set1 {a:Type} {a_WT:WhyType a}(a1:(array a)) (i:BuiltIn.int)
  (v:a): (array a) := (mk_array (length1 a1) (set (elts a1) i v)).

(* Why3 assumption *)
Inductive buffer (a:Type) {a_WT:WhyType a} :=
  | mk_buffer : BuiltIn.int -> BuiltIn.int -> (array a) -> buffer a.
Axiom buffer_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (buffer a).
Existing Instance buffer_WhyType.
Implicit Arguments mk_buffer [[a] [a_WT]].

(* Why3 assumption *)
Definition data {a:Type} {a_WT:WhyType a}(v:(buffer a)): (array a) :=
  match v with
  | (mk_buffer x x1 x2) => x2
  end.

(* Why3 assumption *)
Definition len {a:Type} {a_WT:WhyType a}(v:(buffer a)): BuiltIn.int :=
  match v with
  | (mk_buffer x x1 x2) => x1
  end.

(* Why3 assumption *)
Definition first {a:Type} {a_WT:WhyType a}(v:(buffer a)): BuiltIn.int :=
  match v with
  | (mk_buffer x x1 x2) => x
  end.

(* Why3 assumption *)
Definition size {a:Type} {a_WT:WhyType a}(b:(buffer a)): BuiltIn.int :=
  (length1 (data b)).

(* Why3 assumption *)
Definition buffer_invariant {a:Type} {a_WT:WhyType a}(b:(buffer a)): Prop :=
  ((0%Z <= (first b))%Z /\ ((first b) < (size b))%Z) /\
  ((0%Z <= (len b))%Z /\ ((len b) <= (size b))%Z).

Parameter sequence: forall {a:Type} {a_WT:WhyType a}, (buffer a) -> (list a).

Axiom sequence_def_1 : forall {a:Type} {a_WT:WhyType a}, forall (b:(buffer
  a)), (buffer_invariant b) -> (((len b) = 0%Z) ->
  ((sequence b) = (Nil :(list a)))).

Axiom sequence_def_2 : forall {a:Type} {a_WT:WhyType a}, forall (b:(buffer
  a)), (buffer_invariant b) -> ((0%Z < (len b))%Z ->
  ((((first b) + 1%Z)%Z < (size b))%Z -> ((sequence b) = (Cons (get1 (data b)
  (first b)) (sequence (mk_buffer ((first b) + 1%Z)%Z ((len b) - 1%Z)%Z
  (data b))))))).

Axiom sequence_def_3 : forall {a:Type} {a_WT:WhyType a}, forall (b:(buffer
  a)), (buffer_invariant b) -> ((0%Z < (len b))%Z ->
  ((((first b) + 1%Z)%Z = (size b)) -> ((sequence b) = (Cons (get1 (data b)
  (first b)) (sequence (mk_buffer 0%Z ((len b) - 1%Z)%Z (data b))))))).

Axiom sequence_ind_1 : forall {a:Type} {a_WT:WhyType a}, forall (b:(buffer
  a)), (buffer_invariant b) -> ((0%Z < (len b))%Z ->
  (((((first b) + (len b))%Z - 1%Z)%Z < (size b))%Z ->
  ((sequence b) = (infix_plpl (sequence (mk_buffer (first b)
  ((len b) - 1%Z)%Z (data b))) (Cons (get1 (data b)
  (((first b) + (len b))%Z - 1%Z)%Z) (Nil :(list a))))))).

Axiom sequence_ind_2 : forall {a:Type} {a_WT:WhyType a}, forall (b:(buffer
  a)), (buffer_invariant b) -> ((0%Z < (len b))%Z ->
  (((size b) <= (((first b) + (len b))%Z - 1%Z)%Z)%Z ->
  ((sequence b) = (infix_plpl (sequence (mk_buffer (first b)
  ((len b) - 1%Z)%Z (data b))) (Cons (get1 (data b)
  ((((first b) + (len b))%Z - 1%Z)%Z - (size b))%Z) (Nil :(list a))))))).

(* Why3 goal *)
Theorem sequence_invariance : forall {a:Type} {a_WT:WhyType a},
  forall (b1:(buffer a)) (b2:(buffer a)), (buffer_invariant b1) ->
  ((buffer_invariant b2) -> (((first b1) = (first b2)) ->
  (((len b1) = (len b2)) -> (((size b1) = (size b2)) ->
  ((forall (i:BuiltIn.int), (((first b1) <= i)%Z /\
  (i < ((first b1) + (len b1))%Z)%Z) -> ((i < (size b1))%Z ->
  ((get1 (data b1) i) = (get1 (data b2) i)))) -> ((forall (i:BuiltIn.int),
  ((0%Z <= i)%Z /\ (i < (((first b1) + (len b1))%Z - (size b1))%Z)%Z) ->
  ((get1 (data b1) i) = (get1 (data b2) i))) ->
  ((sequence b1) = (sequence b2)))))))).
(* YOU MAY EDIT THE PROOF BELOW *)
intros a _a b1 b2 h1. 
generalize (refl_equal (len b1)).
generalize (len b1) at 1.
intros z hz.
assert (0 <= z)%Z.
red in h1. omega.
generalize b1 b2 h1 hz. clear b1 b2 h1 hz.
pattern z. apply natlike_ind; auto.
intros.
rewrite sequence_def_1; intuition.
rewrite sequence_def_1; intuition.
intros x hx IH.
intros (f1,len1,d1) (f2,len2,d2).
unfold buffer_invariant, size; simpl; intros. subst.
assert (case: (f2+1 < length1 d1 \/ f2+1 = length1 d1)%Z).
omega.
destruct case.
(* f+1 < size *)
rewrite sequence_def_2; intuition.
rewrite (sequence_def_2 (mk_buffer f2 len2 d2)).
apply f_equal2; intuition.
unfold get1; simpl.
apply H4.
omega.
omega.
apply IH; 
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
(* f+1 = length *)
rewrite sequence_def_3; intuition.
rewrite (sequence_def_3 (mk_buffer f2 len2 d2));
unfold buffer_invariant, first, len, size, data; intuition.
apply f_equal2; intuition.
apply IH; 
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
unfold buffer_invariant, first, len, size, data; intuition.
Qed.


