(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require set.Set.

Import set.Set.

(* Why3 goal *)
Definition integer: (set.Set.set Z).
exact (fun _ => true).
Defined.

(* Why3 goal *)
Lemma mem_integer : forall (x:Z), (set.Set.mem x integer).
auto.
Qed.

(* Why3 goal *)
Definition natural: (set.Set.set Z).
exact (fun n => if Z_ge_lt_dec n 0 then true else false).
Defined.

(* Why3 goal *)
Lemma mem_natural : forall (x:Z), (set.Set.mem x natural) <-> (0%Z <= x)%Z.
intros x.
unfold natural, mem.
destruct (Z_ge_lt_dec x 0); intuition.
discriminate.
Qed.

(* Why3 goal *)
Definition mk: Z -> Z -> (set.Set.set Z).
intros a b.
exact (fun n => if Z_ge_lt_dec n a then 
  if Z_le_gt_dec n b then true else false else false).
Defined.

(* Why3 goal *)
Lemma mem_interval : forall (x:Z) (a:Z) (b:Z), (set.Set.mem x (mk a b)) <->
  ((a <= x)%Z /\ (x <= b)%Z).
intros x a b.
unfold mk, mem.
destruct (Z_ge_lt_dec x a).
destruct (Z_le_gt_dec x b).
intuition.
intuition; discriminate.
intuition; discriminate.
Qed.

(* Why3 goal *)
Lemma interval_empty : forall (a:Z) (b:Z), (b < a)%Z -> ((mk a
  b) = (set.Set.empty :(set.Set.set Z))).
intros a b h1.
apply extensionality; intro x.
rewrite mem_interval.
unfold empty, mem.
intuition; discriminate.
Qed.

(* Why3 goal *)
Lemma interval_add : forall (a:Z) (b:Z), (a <= b)%Z -> ((mk a
  b) = (set.Set.add b (mk a (b - 1%Z)%Z))).
intros a b h1.
apply extensionality; intro x.
rewrite add_def1.
do 2 rewrite mem_interval.
omega.
Qed.


